/*
TASK: frog
LANG: C
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define MAXN 5100
#define MAXYX 5100


int N, Y, X;
int p[MAXN][2];
char gr[MAXN][MAXN];
int P;
int AA, AB;


void read_all(void);
void do_all(void);
int cmp_p(const void *a, const void *b);
void write_all(void);




int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  FILE *f = fopen("frog.in", "rt");
  if (!f)  f = stdin;
  fscanf(f, "%d %d %d", &Y, &X, &N);
  for (i = 0; i < N; i++) {
    fscanf(f, "%d %d", &p[i][0], &p[i][1]);
    p[i][0]--;
    p[i][1]--;
    gr[p[i][0]][p[i][1]] = 1;
  }
  fclose(f);
}



void do_all(void)
{
  int y, x, py, px;
  int i, ip, ip1, y1, x1;

  qsort(p, N, sizeof(p[0]), cmp_p);
  for (ip = 0; ip < N; ip++) {
    y = p[ip][0];
    x = p[ip][1];
    for (ip1 = ip+1; ip1 < N; ip1++) {
      py = p[ip1][0]-p[ip][0];
      px = p[ip1][1]-p[ip][1];
      if (px < 0)  continue;
      if (y-py >= 0 && x-px >= 0)  continue;
      if (y+P*py >= Y || x+P*px >= X) continue;
      AA++;
      for (y1 = y+py, x1 = x+px, i = 1; ; i++) {
        if (y1 >= Y)  break;
        if (x1 >= X)  break;
        if (gr[y1][x1] == 0) {
          i = 0;
          break;
        }
        y1 += py;
        x1 += px;
        AB++;
      }
      if (i > P) {
        P = i;
      }
    }
  }
  if (P < 3)  P = 0;
}



int cmp_p(const void *a, const void *b)
{
  int res;
  res = ((int *)a)[0]-((int *)b)[0];
  if (res == 0)  res = ((int *)a)[1]-((int *)b)[1];
  return res;
}



void write_all(void)
{
  FILE *f = fopen("frog.out", "wt");
  f = stdout;
  fprintf(f, "%d\n", P);
  fclose(f);
}

