/*
TASK: utopia
LANG: C
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define MAXN 10100

int N;
int p[2*MAXN];
int used[2*MAXN];
int ut[MAXN];
int sol[MAXN][2];
int nsol;
int P;
int AA;


void read_all(void);
void do_all(void);
int bt(int y, int x, int ind);
int cmp_p(const void *a, const void *b);
int sgn(int a);
void write_all(void);




int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  FILE *f = fopen("utopia.in", "rt");
  if (!f)  f = stdin;
  fscanf(f, "%d", &N);
  for (i = 0; i < 2*N; i++) {
    fscanf(f, "%d", &p[i]);
  }
  for (i = 0; i < N; i++) {
    fscanf(f, "%d", &ut[i]);
  }
  fclose(f);
}



void do_all(void)
{
  qsort(p, 2*N, sizeof(p[0]), cmp_p);
  P = bt(0, 0, 0);
  if (P == 0)  nsol = 0;
}



int bt(int y, int x, int ind)
{
  int i, j;
  int l, r, d, u;
  int y1, x1;

  if (ind-1 >= 0) {
    if (ut[ind-1] == 1 && (y <= 0 || x <= 0))  return 0;
    if (ut[ind-1] == 2 && (y <= 0 || x >= 0))  return 0;
    if (ut[ind-1] == 3 && (y >= 0 || x >= 0))  return 0;
    if (ut[ind-1] == 4 && (y >= 0 || x <= 0))  return 0;
  }
  if (ind >= N) {
    return 1;
  }
  AA++;
  if (AA%256 == 127 && exectime()>1920)  return 0;
  l = r = d = u = 0;
  if (y >= 0 && ut[ind] >= 3)  d = 1;
  if (y <= 0 && ut[ind] <= 2)  u = 1;
  if (x <= 0 && (ut[ind]==1 || ut[ind]==4))  r = 1;
  if (x >= 0 && (ut[ind]==2 || ut[ind]==3))  l = 1;
  y1 = y;
  x1 = x;
  for (i = 0; i < 2*N; i++) {
    if (used[i])  continue;
    y = y1;
    if (d && y-p[i] >= 0)  break;
    if (u && y+p[i] <= 0)  break;
    used[i] = 1;
    sol[nsol][1] = p[i];
    if (d) {
      y -= p[i];
      sol[nsol][1] *= -1;
    }
    else if (u+d == 0) {
      int n1, n2;
      n1 = y-p[i];
      n2 = y+p[i];
      if (abs(n1) < abs(n2)) {
        if (sgn(n1) == sgn(y))  y = n1, sol[nsol][1] *= -1;
        else  y = n2;
      }
      else {
        if (sgn(n2) == sgn(y))  y = n2;
        else  y = n1, sol[nsol][1] *= -1;
      }
    }
    else {
      y += p[i];
    }
    for (j = 0; j < 2*N; j++) {
      if (used[j])  continue;
      x = x1;
      if (l && x-p[j] >= 0)  break;
      if (r && x+p[j] <= 0)  break;
      used[j] = 1;
      sol[nsol][0] = p[j];
      if (l) {
        x -= p[j];
        sol[nsol][0] *= -1;
      }
      else if (l+r == 0) {
        int n1, n2;
        n1 = x-p[j];
        n2 = x+p[j];
        if (abs(n1) < abs(n2)) {
          if (sgn(n1) == sgn(x))  x = n1, sol[nsol][0] *= -1;
          else  x = n2;
        }
        else {
          if (sgn(n2) == sgn(x))  x = n2;
          else  x = n1, sol[nsol][0] *= -1;
        }
      }
      else {
        x += p[j];
      }
      nsol++;
      if (bt(y, x, ind+1))  return 1;
      nsol--;
      used[j] = 0;
    }
    used[i] = 0;
  }
  return 0;
}



int cmp_p(const void *a, const void *b)
{
  int res;

  res = ((int *)a)[0]-((int *)b)[0];
  return -res;
}



int sgn(int a)
{
  if (a > 0)  return 1;
  if (a < 0)  return -1;
  return 0;
}



void write_all(void)
{
  int i;
  
  FILE *f = fopen("utopia.out", "wt");
  f = stdout;
  for (i = 0; i < nsol; i++) {
    fprintf(f, "%s%d %s%d\n", (sol[i][0]>=0)?"+":"", sol[i][0], (sol[i][1]>=0)?"+":"", sol[i][1]);
  }
  fclose(f);
}

