/*
TASK: xor
LANG: C
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define MAXN 2048
#define MAXSOL 40100
#define MAXCUT 2
#define MAXCUTALLOWED 1


#define  INFILE "xor.in10"
#define OUTFILE "xor.ou10"
#define FILENUM 10


int N;
short g[MAXN][MAXN];
int sol[MAXSOL][4];
int nsol;
int bestsol[MAXSOL][4];
int bestnsol;
int P;


void read_all(void);
void do_all(void);
void invert(int x1, int x2, int y1, int y2);
int DFS(int dep);
void write_all(void);




int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int y, x, a;
  char s[MAXN+10];
  
  FILE *f = fopen(INFILE, "rt");
  if (!f)  f = stdin;
  fscanf(f, "%d", &N);
  fgets(s, sizeof(s), f);
  for (y = 0; y < N; y++) {
    fgets(s, sizeof(s), f);
    for (x = 0; x < N; x++) {
      if (s[x] == '#')  g[y][x] = 1;
    }
  }
  fclose(f);
}



void do_all(void)
{
  P = MAXSOL;
  bestnsol = P;
  DFS(0);
  printf("%s %d\n", INFILE, bestnsol);
}



int DFS(int dep)
{
  int y, x, i, j;
  int x1, x2;
  int cut[MAXCUT];
  int ncut, ma;
  int lasty;

  y = 0;
  lasty = -1;
for (;;) {
  if (y-3 >= 0)  y-= 3;
  for (; y < N; y++) {
    x1 = x2 = -1;
    for (x = 0; x < N; x++) {
      if (x1 == -1 && g[y][x] == 0)  continue;
      if (x1 >  -1 && g[y][x] == 0)  break;
      x2 = x;
      if (x1 == -1)  x1 = x;
    }
    if (x1 > -1)  break;
  }
  if (y > lasty && y %20 == 0
  ) {
    lasty = y;
    printf("%d / %d\n", y, N);
  }
  if (y >= N) {
    if (nsol < bestnsol) {
      P = dep;
      bestnsol = nsol;
      memmove(bestsol, sol, sizeof(sol));
      printf("%s %d\n", INFILE, bestnsol);
      write_all();
    }
    return 0;
  }
  ncut = 0;
  for (i = y+1; i < N; i++) {
    for (j = x1; j <= x2; j++) {
      if (g[i][j] != g[i-1][j])  break;
    }
    if (j <= x2) {
      cut[ncut++] = i-1;
      break;
    }
    if (ncut >= MAXCUT-1)  break;
  }
  if (ncut == 0)  cut[ncut++] = y;
/*  if (ncut > 1)  ncut = 1;*/
  for (i = 1; i < ncut; i++) {
    if (rand()%3)  cut[i] = -1;
  }
  ma = MAXCUTALLOWED;
  for (i = 0; i < ncut; i++) {
    if (cut[i] == -1)  continue;
    invert(x1, x2, y, cut[i]);
    sol[nsol][0] = x1;
    sol[nsol][1] = x2;
    sol[nsol][2] = y;
    sol[nsol][3] = cut[i];
    if (sol[nsol][0] > sol[nsol][1] || sol[nsol][2] > sol[nsol][3]) {
      printf("err!");
      exit(1);
    }
    nsol++;
    break;
  }
}
  return 0;
}



void invert(int x1, int x2, int y1, int y2)
{
  int i, j;

  for (i = y1; i <= y2; i++) {
    for (j = x1; j <= x2; j++) {
      g[i][j] = 1-g[i][j];
    }
  }
}



void write_all(void)
{
  int i;
  
  FILE *f = fopen(OUTFILE, "wt");
  fprintf(f, "#FILE xor %d\n", FILENUM);
  fprintf(f, "%d\n", bestnsol);
  for (i = 0; i < bestnsol; i++) {
    fprintf(f, "%d %d %d %d\n", 1+bestsol[i][0], 1+bestsol[i][1], 1+bestsol[i][2], 1+bestsol[i][3]);
  }
  fclose(f);
}

