/*
TASK: bus
LANG: C
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define MAXN 512

int N;
int p[MAXN][8];
int p1[MAXN][8];
int dist[MAXN][MAXN];
int bad[MAXN];
int ind1[MAXN];
int ind2[MAXN];
int P;



void read_all(void);
void do_all(void);
int cmp_x(const void *a, const void *b);
int cmp_y(const void *a, const void *b);
int cmp_5(const void *a, const void *b);
int cmp_6(const void *a, const void *b);
int cmp_7(const void *a, const void *b);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  FILE *f = fopen("bus.in", "rt");
  f = stdin;
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) {
    fscanf(f, "%d %d", &p[i][0], &p[i][1]);
  }
  fclose(f);
}



void do_all(void)
{
  int i, j, k, k1, k2;
  int ii, jj;
  int d, d1, d2, d3, d4;
  int maxd;
  int sumx, sumy;
  int b1, b2;
  int dx, dy;

  P = 100000;
  sumx = sumy = 0;
  memmove(p1, p, sizeof(p));
  for (i = 0; i < N; i++) {
    sumx += p[i][0];
    sumy += p[i][1];
  }
  for (i = 0; i < N; i++) {
    p[i][2] = i;
  }
  qsort(p, N, sizeof(p[0]), cmp_x);
  for (i = 0; i < N; i++)  p[i][3] = i;
  qsort(p, N, sizeof(p[0]), cmp_y);
  for (i = 0; i < N; i++)  p[i][4] = i;
  b1 = .3*N;
  b2 = N-.3*N;
  for (i = 0; i < N; i++) {
    dx = abs(p[i][3]-b1);
    if (abs(p[i][3]-b2) < dx)  dx = abs(p[i][3]);
    dy = abs(p[i][4]-b1);
    if (abs(p[i][4]-b2) < dy)  dy = abs(p[i][4]);
    p[i][5] = dx+dy;
    p[i][6] = abs(p[i][3]-b1);
    p[i][7] = abs(p[i][4]-b2);
  }

  qsort(p, N, sizeof(p[0]), cmp_6);
  for (i = 0; i < N; i++)  ind1[i] = p[i][2];
  qsort(p, N, sizeof(p[0]), cmp_7);
  for (i = 0; i < N; i++)  ind2[i] = p[i][2];
  qsort(p, N, sizeof(p[0]), cmp_5);
  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {
      dist[i][j] = abs(p[i][0]-p[j][0]) + abs(p[i][1]-p[j][1]);
    }
  }
  
  for (ii = 0; ii < N; ii++) {
    i = ind1[ii];
    if (bad[i])  continue;
    for (jj = 0; jj < N; jj++) {
      j = ind2[jj];
      if (j <= i)  continue;
      if (bad[j] || bad[i])  continue;
      maxd = dist[i][j];
      if (maxd > P)  continue;
      if (exectime() > 3900)  return;
      for (k1 = 0; k1 < N; k1++) {
        for (k2 = k1+1; k2 < N; k2++) {
          d1 = dist[k1][i] + dist[k2][i];
          d2 = dist[k1][j] + dist[k2][j];
          d3 = dist[k1][i] + dist[k2][j] + dist[i][j];
          d4 = dist[k1][j] + dist[k2][i] + dist[i][j];
          d = d1;
          if (d2 < d)  d = d2;
          if (d3 < d)  d = d3;
          if (d4 < d)  d = d4;
          if (d > maxd)  maxd = d;
          if (maxd > P) {
            if (d == d1)  bad[i] = 1;
            if (d == d2)  bad[j] = 1;
          }
          if (maxd > P)  break;
        }
        if (maxd > P)  break;
      }
      if (maxd < P) {
        P = maxd;
/*        printf("%d - %d\n", exectime(), P);*/
      }
    }
  }
}



int cmp_x(const void *a, const void *b)
{
  int res;

  res = ((int *)a)[0] - ((int *)b)[0];
  if (res == 0)  res = ((int *)a)[1] - ((int *)b)[1];
  return res;
}



int cmp_y(const void *a, const void *b)
{
  int res;

  res = ((int *)a)[1] - ((int *)b)[1];
  if (res == 0)  res = ((int *)a)[0] - ((int *)b)[0];
  return res;
}



int cmp_5(const void *a, const void *b)
{
  int res = ((int *)a)[5] - ((int *)b)[5];
  return res;
}



int cmp_6(const void *a, const void *b)
{
  int res = ((int *)a)[6] - ((int *)b)[6];
  return res;
}



int cmp_7(const void *a, const void *b)
{
  int res = ((int *)a)[7] - ((int *)b)[7];
  return res;
}



void write_all(void)
{
  FILE *f/* = fopen(".out", "wt")*/;
  f = stdout;
  fprintf(f, "%d\n", P);
  fclose(f);
}

