{
TASK: rods
LANG: PASCAL
}

{$MODE objfpc}

Uses
  prectlib;

Var
{  tophack : Boolean;}
  N : integer;
  ctop, cbottom, cleft, cright : Integer;
  horizX1, horizX2 : Integer;
  horizY : Integer;
  vertY1, vertY2 : Integer;
  vertX : Integer;

Procedure done;

Begin
  report(horizY, horizX1, horizY, horizX2, vertY1, vertX, vertY2, vertX);
  Halt;
End;

Procedure checkdone;

Begin
{  Writeln('cd');
  Writeln(horizY);
  Writeln(horizX1);
  Writeln(horizX2);
  Writeln(vertX);
  Writeln(vertY1);
  Writeln(vertY2);}
  If (horizY <> -1) And (horizX1 <> -1) And (horizX2 <> -1) And
     (vertX <> -1) And (vertY1 <> -1) And (vertY2 <> -1) Then
    done;
End;

Function test(X1, Y1, X2, Y2 : Integer) : Boolean;

Var
  tmp : Integer;

Begin
  If X1 > X2 Then
  Begin
    tmp := X1;
    X1 := X2;
    X2 := tmp;
  End;
  If Y1 > Y2 Then
  Begin
    tmp := Y1;
    Y1 := Y2;
    Y2 := tmp;
  End;
  If (X2 < 1) Or (X1 > N) Or (Y2 < 1) Or (Y1 > N) Then
    Exit(False);
  If X1 < 1 Then
    X1 := 1;
  If X2 > N Then
    X2 := N;
  If Y1 < 1 Then
    Y1 := 1;
  If Y2 > N Then
    Y2 := N;
  test := rect(Y1, Y2, X1, X2) = 1;
End;

Procedure cliptop;

Var
  L, R, M : Integer;
  cmp : Boolean;

Begin
  L := 1;
  R := N;

  While L <= R Do
  Begin
    M := (L + R) Div 2;
    cmp := test(1, 1, N, M);
    If cmp Then
      R := M - 1
    Else
      L := M + 1;
  End;
  ctop := L;
End;

Procedure clipbottom;

Var
  L, R, M : Integer;
  cmp : Boolean;

Begin
  L := N;
  R := 1;

  While L >= R Do
  Begin
    M := (L + R) Div 2;
    cmp := test(1, M, N, N);
    If cmp Then
      R := M + 1
    Else
      L := M - 1;
  End;
  cbottom := L;
End;

Procedure clipleft;

Var
  L, R, M : Integer;
  cmp : Boolean;

Begin
  L := 1;
  R := N;

  While L <= R Do
  Begin
    M := (L + R) Div 2;
    cmp := test(1, 1, M, N);
    If cmp Then
      R := M - 1
    Else
      L := M + 1;
  End;
  cleft := L;
End;

Procedure clipright;

Var
  L, R, M : Integer;
  cmp : Boolean;

Begin
  L := N;
  R := 1;

  While L >= R Do
  Begin
    M := (L + R) Div 2;
    cmp := test(M, 1, N, N);
    If cmp Then
      R := M + 1
    Else
      L := M - 1;
  End;
  cright := L;
End;

Procedure locatehoriz;

Var
  L, R, M : Integer;
  lim : Integer;
  cmp : Boolean;

Begin
  If horizY = -1 Then
  Begin
    Exit;
{    Writeln('guz');
    Halt;}
  End;

  If horizX1 = -1 Then
  Begin
    L := 1;
    R := N;

    While L <= R Do
    Begin
      M := (L + R) Div 2;
      cmp := test(1, horizY, M, horizY);
      If cmp Then
        R := M - 1
      Else
        L := M + 1;
    End;
    {something at L, horizY}
    If test(L + 1, horizY, L + 1, horizY) Then
      horizX1 := L
    Else
    Begin
      vertX := L;

      lim := L + 2;
      L := lim;
      R := N;

      While L <= R Do
      Begin
        M := (L + R) Div 2;
        cmp := test(lim, horizY, M, horizY);
        If cmp Then
          R := M - 1
        Else
          L := M + 1;
      End;
      horizX1 := L;
    End;
  End;

  If horizX2 = -1 Then
  Begin
    L := N;
    R := 1;

    While L >= R Do
    Begin
      M := (L + R) Div 2;
      cmp := test(M, horizY, N, horizY);
      If cmp Then
        R := M + 1
      Else
        L := M - 1;
    End;
    {something at L, horizY}
    If test(L - 1, horizY, L - 1, horizY) Then
      horizX2 := L
    Else
    Begin
      vertX := L;

      lim := L - 2;
      L := lim;
      R := 1;

      While L >= R Do
      Begin
        M := (L + R) Div 2;
        cmp := test(M, horizY, lim, horizY);
        If cmp Then
          R := M + 1
        Else
          L := M - 1;
      End;

      horizX2 := L;
    End;
  End;
  Writeln('h', horizY, ' ', horizX1, ' ', horizX2);

  checkdone;
End;

Procedure locatevert;

Var
  L, R, M : Integer;
  lim : Integer;
  cmp : Boolean;

Begin
  If vertX = -1 Then
  Begin
{    Writeln('guz');
    Halt;}
    Exit;
  End;

  If vertY1 = -1 Then
  Begin
    L := 1;
    R := N;

    While L <= R Do
    Begin
      M := (L + R) Div 2;
      cmp := test(vertX, 1, vertX, M);
      If cmp Then
        R := M - 1
      Else
        L := M + 1;
    End;
    {something at vertX, L}
    If test(vertX, L + 1, vertX, L + 1) Then
      vertY1 := L
    Else
    Begin
      horizY := L;

      lim := L + 2;
      L := lim;
      R := N;

      While L <= R Do
      Begin
        M := (L + R) Div 2;
        cmp := test(vertX, lim, vertX, M);
        If cmp Then
          R := M - 1
        Else
          L := M + 1;
      End;
      vertY1 := L;
    End;
  End;

  If vertY2 = -1 Then
  Begin
    L := N;
    R := 1;

    While L >= R Do
    Begin
      M := (L + R) Div 2;
      cmp := test(vertX, M, vertX, N);
      If cmp Then
        R := M + 1
      Else
        L := M - 1;
    End;
    {something at vertX, L}
    If test(vertX, L - 1, vertX, L - 1) Then
      vertY2 := L
    Else
    Begin
      horizY := L;

      lim := L - 2;
      L := L - 2;
      R := 1;

      While L >= R Do
      Begin
        M := (L + R) Div 2;
        cmp := test(vertX, M, vertX, lim);
        If cmp Then
          R := M + 1
        Else
          L := M - 1;
      End;

      vertY2 := L;
    End;
  End;
  Writeln('v', vertX, ' ', vertY1, ' ', vertY2);

  checkdone;
End;

Procedure Bahur;

Var
  L, R, M : Integer;
  cmp : Boolean;

Begin
{  cliptop;}
  L := {cleft}1;
  R := {cright}N;
  While L <= R Do
  Begin
    M := (L + R) Div 2;
    cmp := test(1, ctop, M, ctop);
    If cmp Then
      R := M - 1
    Else
      L := M + 1;
  End;
  {we found something at (L, ctop)}
  If test(L + 1, ctop, L + 1, ctop) Then
  Begin {horiz!!!}
    horizY := ctop;
{    horizX1 := L;}
    locatehoriz;
  End
  Else
  Begin {vert}
    vertX := L;
    vertY1 := ctop;
    If {tophack And} test(vertX, vertY1 - 1, vertX, vertY1 - 1) Then
      Dec(vertY1);
    locatevert;
  End;
  If vertX <> -1 Then
    locatevert;
  If horizY <> -1 Then
    locatehoriz;
End;

Var
  L, R, M, lim : Integer;
  cmp : Boolean;

Begin
  ctop := 0;
  cleft := 0;
  cbottom := N;
  cright := N;
  n := gridsize;
{  cliptop;
  clipbottom;
  clipleft;
  clipright;}

{  Writeln('top', ctop);
  Writeln('bottom', cbottom);
  Writeln('left', cleft);
  Writeln('right', cright);}

  horizY := -1;
  horizX1 := -1;
  horizX2 := -1;
  vertX := -1;
  vertY1 := -1;
  vertY2 := -1;

{  tophack := False;}
  cliptop;
  Bahur;
  If horizY <> -1 Then
  Begin
    lim := ctop + 1;
{    Inc(ctop);}

{    tophack := True;}

    L := lim;
    R := N;

    While L <= R Do
    Begin
      M := (L + R) Div 2;
      cmp := test(1, lim, N, M);
      If cmp Then
        R := M - 1
      Else
        L := M + 1;
    End;
    ctop := L;

{    If ctop = (lim - 1) Then
      tophack := True;}

    Bahur;
  End
  Else
  Begin {we have found the vertical rod}
{    clipleft;}
    If test(1, 1, vertX - 1, N) Then
    Begin {on the left?}
      lim := vertX - 1;

      L := 1;
      R := N;

      While L <= R Do
      Begin
        M := (L + R) Div 2;
        cmp := test(1, 1, lim, M);
        If cmp Then
          R := M - 1
        Else
          L := M + 1;
      End;
      horizY := L;
      locatehoriz;
    End
    Else
    Begin
      lim := vertX + 1;

      L := 1;
      R := N;

      While L <= R Do
      Begin
        M := (L + R) Div 2;
        cmp := test(lim, 1, N, M);
        If cmp Then
          R := M - 1
        Else
          L := M + 1;
      End;
      horizY := L;
      locatehoriz;
    End;
  End;

  checkdone;

{  writeln ('gridsize = ', n);
  writeln ('rect(3, 6, 3, 8) = ', rect(3, 6, 3, 8));
  writeln ('rect(1, 5, 1, 3) = ', rect(1, 5, 1, 3));
  report (4, 3, 4, 8, 4, 4, 9, 4);}
End.
